Index: /LMDZ5/branches/testing/libf/phylmd/pppmer.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/pppmer.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/pppmer.F90	(revision 2408)
@@ -0,0 +1,161 @@
+SUBROUTINE PPPMER(KPROMA,KSTART,KPROF,PRPRESS,POROG,PTSTAR,PT0,PMSLPPP)
+
+!**** *PPPMER* - POST-PROCESS MSL PRESSURE.
+
+!     PURPOSE.
+!     --------
+!           COMPUTES MSL PRESSURE.
+
+!**   INTERFACE.
+!     ----------
+
+!        *CALL* *PPPMER(KPROMA,KSTART,KPROF,PRPRESS,POROG,PTSTAR,PT0,
+!    S                  PMSLPPP)
+
+!        EXPLICIT ARGUMENTS
+!        --------------------
+
+
+!        KPROMA                    - HORIZONTAL DIMENSION.             (INPUT)
+!        KSTART                    - START OF WORK.                    (INPUT)
+!        KPROF                     - DEPTH OF WORK.                    (INPUT)
+!        PRPRESS(KPROMA)           - SURFACE PRESSURE                  (INPUT)
+!        POROG(KPROMA)             - MODEL OROGRAPHY.                  (INPUT)
+!        PTSTAR(KPROMA)            - SURFACE TEMPERATURE               (INPUT)
+!        PT0(KPROMA)               - STANDARD SURFACE TEMPERATURE      (INPUT)
+!        PMSLPPP(KPROMA)           - POST-PROCESSED MSL PRESSURE       (OUTPUT)
+!        IMPLICIT ARGUMENTS :  CONSTANTS FROM YOMCST,YOMGEM,YOMSTA.
+!        --------------------
+
+!     METHOD.
+!     -------
+!        SEE DOCUMENTATION
+
+!     EXTERNALS.  NONE
+!     ----------
+
+!     REFERENCE.
+!     ----------
+!        ECMWF Research Department documentation of the IFS
+
+!     AUTHOR.
+!     -------
+!        MATS HAMRUD AND PHILIPPE COURTIER  *ECMWF*
+
+!     MODIFICATIONS.
+!     --------------
+!        ORIGINAL : 89-01-26
+
+!     E. A-son, J-F Geleyn 920409 Mod. T*, T0 and alpha below surface.
+!        M.Hamrud      01-Oct-2003 CY28 Cleaning
+
+!     ------------------------------------------------------------------
+
+! USE PARKIND1 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/module/parkind1.F90.php#parkind1>  ,ONLY : JPIM     ,JPRB
+! USE YOMHOOK 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/module/yomhook.F90.php#yomhook>   ,ONLY : LHOOK,   DR_HOOK
+
+!USE YOMCST, ONLY : RG, RD
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/arp/module/yomcst.F90.php#yomcst>   , ONLY : RG
+
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/support/rg.F.php#rg>       ,RD
+! USE YOMSTA 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/arp/module/yomsta.F90.php#yomsta>   , ONLY : RDTDZ1
+
+  IMPLICIT NONE
+
+include "YOMCST.h"
+!IM INTEGER(KIND=JPIM),INTENT(IN)    :: KPROMA
+!IM INTEGER(KIND=JPIM),INTENT(IN)    :: KSTART
+!IM INTEGER(KIND=JPIM),INTENT(IN)    :: KPROF
+ INTEGER,INTENT(IN)    :: KPROMA
+ INTEGER,INTENT(IN)    :: KSTART
+ INTEGER,INTENT(IN)    :: KPROF
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: PRPRESS(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: POROG(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: PTSTAR(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: PT0(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMSLPPP(KPROMA)
+!IM REAL(KIND=JPRB) :: ZTSTAR(KPROMA)
+!IM REAL(KIND=JPRB) :: ZALPHA(KPROMA)
+ REAL,INTENT(IN)    :: PRPRESS(KPROMA)
+ REAL,INTENT(IN)    :: POROG(KPROMA)
+ REAL,INTENT(IN)    :: PTSTAR(KPROMA)
+ REAL,INTENT(IN)    :: PT0(KPROMA)
+ REAL,INTENT(OUT)   :: PMSLPPP(KPROMA)
+ REAL :: ZTSTAR(KPROMA)
+ REAL :: ZALPHA(KPROMA)
+
+!IM INTEGER(KIND=JPIM) :: JL
+ INTEGER :: JL
+
+!IM REAL(KIND=JPRB) :: ZDTDZSG, ZOROG, ZT0, ZTX, ZTY, ZX, ZY, ZY2
+!IM REAL(KIND=JPRB) :: ZHOOK_HANDLE
+ REAL :: ZDTDZSG, ZOROG, ZT0, ZTX, ZTY, ZX, ZY, ZY2
+ REAL :: ZHOOK_HANDLE
+!IM beg
+REAL, PARAMETER                  :: RDTDZ1=-0.0065 !or USE YOMSTA
+!IM end
+
+!     ------------------------------------------------------------------
+
+!*       1.    POST-PROCESS MSL PRESSURE.
+!              --------------------------
+
+!*       1.1   COMPUTATION OF MODIFIED ALPHA AND TSTAR.
+
+!IM IF (LHOOK) CALL DR_HOOK('PPPMER',0,ZHOOK_HANDLE)
+!IM ZTX=290.5_JPRB
+!IM ZTY=255.0_JPRB
+ ZTX=290.5
+ ZTY=255.0
+ ZDTDZSG=-RDTDZ1/RG 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/support/rg.F.php#rg>
+ DO JL=KSTART,KPROF
+
+   IF(PTSTAR(JL) < ZTY) THEN
+!IM  ZTSTAR(JL)=0.5_JPRB*(ZTY+PTSTAR(JL))
+     ZTSTAR(JL)=0.5*(ZTY+PTSTAR(JL))
+   ELSEIF(PTSTAR(JL) < ZTX) THEN
+     ZTSTAR(JL)=PTSTAR(JL)
+   ELSE
+!IM    ZTSTAR(JL)=0.5_JPRB*(ZTX+PTSTAR(JL))
+     ZTSTAR(JL)=0.5*(ZTX+PTSTAR(JL))
+   ENDIF
+
+   ZT0=ZTSTAR(JL)+ZDTDZSG*POROG(JL)
+   IF(ZTX > ZTSTAR(JL) .AND. ZT0 > ZTX) THEN
+     ZT0=ZTX
+   ELSEIF(ZTX <= ZTSTAR(JL) .AND. ZT0 > ZTSTAR(JL)) THEN
+     ZT0=ZTSTAR(JL)
+   ELSE
+     ZT0=PT0(JL)
+   ENDIF
+
+!IM  ZOROG=SIGN(MAX(1.0_JPRB,ABS(POROG(JL))),POROG(JL))
+   ZOROG=SIGN(MAX(1.0,ABS(POROG(JL))),POROG(JL))
+   ZALPHA(JL)=RD*(ZT0-ZTSTAR(JL))/ZOROG
+ ENDDO
+
+!*       1.2   COMPUTATION OF MSL PRESSURE.
+
+ DO JL=KSTART,KPROF
+!IM  IF (ABS(POROG(JL)) >= 0.001_JPRB) THEN
+   IF (ABS(POROG(JL)) >= 0.001) THEN
+     ZX=POROG(JL)/(RD*ZTSTAR(JL))
+     ZY=ZALPHA(JL)*ZX
+     ZY2=ZY*ZY
+
+!IM    PMSLPPP(JL)=PRPRESS(JL)*EXP(ZX*(1.0_JPRB-0.5_JPRB*ZY+1.0_JPRB/3._JPRB*ZY2))
+     PMSLPPP(JL)=PRPRESS(JL)*EXP(ZX*(1.0-0.5*ZY+1.0/3.*ZY2))
+   ELSE
+     PMSLPPP(JL)=PRPRESS(JL)
+   ENDIF
+ ENDDO
+
+
+!     ------------------------------------------------------------------
+
+!IM IF (LHOOK) CALL DR_HOOK('PPPMER',1,ZHOOK_HANDLE)
+ END SUBROUTINE PPPMER
Index: /LMDZ5/branches/testing/libf/phylmd/radiation_AR4.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/radiation_AR4.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/radiation_AR4.F90	(revision 2408)
@@ -6,11 +6,8 @@
     psolswai, ok_ade, ok_aie)
   USE dimphy
+  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
 
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "YOMCST.h"
-  include "iniprint.h"
 
   ! ------------------------------------------------------------------
@@ -317,7 +314,4 @@
     rtdumg, rth2o, rtumg
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "radepsi.h"
   include "radopt.h"
@@ -485,5 +479,5 @@
   USE dimphy
   USE radiation_ar4_param, ONLY: rsun, rray
-  USE infotrac, ONLY: type_trac
+  USE infotrac_phy, ONLY: type_trac
 #ifdef REPROBUS
   USE chem_rep, ONLY: rsuntime, ok_suntime
@@ -491,8 +485,4 @@
 
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"i
-  include "iniprint.h"
 
   ! ------------------------------------------------------------------
@@ -710,5 +700,5 @@
   USE dimphy
   USE radiation_ar4_param, ONLY: rsun, rray
-  USE infotrac, ONLY: type_trac
+  USE infotrac_phy, ONLY: type_trac
 #ifdef REPROBUS
   USE chem_rep, ONLY: rsuntime, ok_suntime
@@ -716,7 +706,4 @@
 
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "radepsi.h"
 
@@ -1211,7 +1198,4 @@
   USE radiation_ar4_param, ONLY: taua, rpiza, rcga
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "radepsi.h"
   include "radopt.h"
@@ -1542,7 +1526,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "radepsi.h"
   include "radopt.h"
@@ -1872,7 +1853,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
 
   ! ------------------------------------------------------------------
@@ -1999,7 +1977,4 @@
   USE radiation_ar4_param, ONLY: apad, bpad, d
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
 
   ! -----------------------------------------------------------------------
@@ -2071,7 +2046,4 @@
   USE radiation_ar4_param, ONLY: apad, bpad, d
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
 
   ! -----------------------------------------------------------------------
@@ -2152,11 +2124,8 @@
     plwup, plwdn, plwup0, plwdn0)
   USE dimphy
+  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
   include "YOMCST.h"
-  include "iniprint.h"
 
   ! -----------------------------------------------------------------------
@@ -2343,5 +2312,5 @@
   USE dimphy
   USE radiation_ar4_param, ONLY: tref, rt1, raer, at, bt, oct
-  USE infotrac, ONLY: type_trac
+  USE infotrac_phy, ONLY: type_trac
 #ifdef REPROBUS
   USE chem_rep, ONLY: rch42d, rn2o2d, rcfc112d, rcfc122d, ok_rtime2d
@@ -2349,7 +2318,4 @@
 
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
   include "YOMCST.h"
@@ -2715,7 +2681,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
   include "YOMCST.h"
@@ -2804,7 +2767,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "radepsi.h"
   include "radopt.h"
@@ -3184,7 +3144,4 @@
   USE radiation_ar4_param, ONLY: tintp, xp, ga, gb
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
 
@@ -4586,7 +4543,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
   include "YOMCST.h"
@@ -4694,7 +4648,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
   include "radopt.h"
@@ -4996,7 +4947,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
 
@@ -5232,7 +5180,4 @@
   USE radiation_ar4_param, ONLY: wg1
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
 
@@ -5427,7 +5372,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
 
@@ -5603,7 +5545,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "raddim.h"
   include "raddimlw.h"
 
Index: /LMDZ5/branches/testing/libf/phylmd/radio_decay.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/radio_decay.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/radio_decay.F90	(revision 2408)
@@ -7,5 +7,5 @@
 !
   USE dimphy
-  USE infotrac, ONLY : nbtr
+  USE infotrac_phy, ONLY : nbtr
   USE traclmdz_mod, ONLY : id_rn, id_pb
   IMPLICIT NONE
Index: /LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2408)
@@ -24,5 +24,5 @@
    qsat, flwc, fiwc, &
    ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
-   heat,heat0,cool,cool0,radsol,albpla,&
+   heat,heat0,cool,cool0,albpla,&
    topsw,toplw,solsw,sollw,&
    sollwdown,&
@@ -48,5 +48,5 @@
   USE DIMPHY
   USE assert_m, ONLY : assert
-  USE infotrac, ONLY : type_trac
+  USE infotrac_phy, ONLY : type_trac
   USE write_field_phy
 #ifdef REPROBUS
@@ -77,7 +77,6 @@
       USE YOERRTWN , ONLY : DELWAVE   ,TOTPLNK      
       USE YOMPHY3  , ONLY : RII0
-#else
-      USE aero_mod, ONLY : nbands_lw_rrtm
 #endif
+      USE aero_mod
 
   !======================================================================
@@ -111,5 +110,4 @@
   ! heat-----output-R- echauffement atmospherique (visible) (K/jour)
   ! cool-----output-R- refroidissement dans l'IR (K/jour)
-  ! radsol---output-R- bilan radiatif net au sol (W/m**2) (+ vers le bas)
   ! albpla---output-R- albedo planetaire (entre 0 et 1)
   ! topsw----output-R- flux solaire net au sommet de l'atm.
@@ -171,5 +169,4 @@
   include "YOMCST.h"
   include "clesphys.h"
-  include "iniprint.h"
 
 ! Input arguments
@@ -195,7 +192,7 @@
   LOGICAL, INTENT(in)  :: flag_aerosol_strat                             ! use stratospheric aerosols
   REAL,    INTENT(in)  :: cldfra(KLON,KLEV), cldemi(KLON,KLEV), cldtaupd(KLON,KLEV)
-  REAL,    INTENT(in)  :: tau_aero(KLON,KLEV,9,2)                        ! aerosol optical properties (see aeropt.F)
-  REAL,    INTENT(in)  :: piz_aero(KLON,KLEV,9,2)                        ! aerosol optical properties (see aeropt.F)
-  REAL,    INTENT(in)  :: cg_aero(KLON,KLEV,9,2)                         ! aerosol optical properties (see aeropt.F)
+  REAL,    INTENT(in)  :: tau_aero(KLON,KLEV,naero_grp,2)                        ! aerosol optical properties (see aeropt.F)
+  REAL,    INTENT(in)  :: piz_aero(KLON,KLEV,naero_grp,2)                        ! aerosol optical properties (see aeropt.F)
+  REAL,    INTENT(in)  :: cg_aero(KLON,KLEV,naero_grp,2)                         ! aerosol optical properties (see aeropt.F)
 !--OB
   REAL,    INTENT(in)  :: tau_aero_sw_rrtm(KLON,KLEV,2,NSW)                 ! aerosol optical properties RRTM
@@ -225,5 +222,5 @@
   REAL,    INTENT(out) :: heat(KLON,KLEV), cool(KLON,KLEV)
   REAL,    INTENT(out) :: heat0(KLON,KLEV), cool0(KLON,KLEV)
-  REAL,    INTENT(out) :: radsol(KLON), topsw(KLON), toplw(KLON)
+  REAL,    INTENT(out) :: topsw(KLON), toplw(KLON)
   REAL,    INTENT(out) :: solsw(KLON), sollw(KLON), albpla(KLON)
   REAL,    INTENT(out) :: topsw0(KLON), toplw0(KLON), solsw0(KLON), sollw0(KLON)
@@ -293,7 +290,7 @@
   REAL(KIND=8) zsolsw0(kdlon), zsollw0(kdlon)
   REAL(KIND=8) zznormcp
-  REAL(KIND=8) tauaero(kdlon,kflev,9,2)                     ! aer opt properties
-  REAL(KIND=8) pizaero(kdlon,kflev,9,2)
-  REAL(KIND=8) cgaero(kdlon,kflev,9,2)
+  REAL(KIND=8) tauaero(kdlon,kflev,naero_grp,2)                     ! aer opt properties
+  REAL(KIND=8) pizaero(kdlon,kflev,naero_grp,2)
+  REAL(KIND=8) cgaero(kdlon,kflev,naero_grp,2)
   REAL(KIND=8) PTAUA(kdlon,2,kflev)                         ! present-day value of cloud opt thickness (PTAU is pre-industrial value), local use
   REAL(KIND=8) POMEGAA(kdlon,2,kflev)                       ! dito for single scatt albedo
@@ -393,9 +390,9 @@
   IF (nb_gr*kdlon .NE. KLON) THEN
       PRINT*, "kdlon mauvais:", KLON, kdlon, nb_gr
-      call abort_gcm("radlwsw", "", 1)
+      call abort_physic("radlwsw", "", 1)
   ENDIF
   IF (kflev .NE. KLEV) THEN
       PRINT*, "kflev differe de KLEV, kflev, KLEV"
-      call abort_gcm("radlwsw", "", 1)
+      call abort_physic("radlwsw", "", 1)
   ENDIF
   !-------------------------------------------
@@ -1000,5 +997,7 @@
           zalbpla(i)   = ZFSUP(i,klev+1)/ZFSDN(i,klev+1)
          ENDIF
-         zsollwdown(i)= ZFLDN(i,1)
+!!! 5 juin 2015
+!!! Correction MP bug RRTM
+         zsollwdown(i)= -1.*ZFLDN(i,1)
       ENDDO
 !     print*,'OK2'
@@ -1025,5 +1024,5 @@
 #else
     abort_message="You should compile with -rrtm if running with iflag_rrtm=1"
-    call abort_gcm(modname, abort_message, 1)
+    call abort_physic(modname, abort_message, 1)
 #endif
     ENDIF ! iflag_rrtm
@@ -1031,5 +1030,4 @@
 
     DO i = 1, kdlon
-      radsol(iof+i) = zsolsw(i) + zsollw(i)
       topsw(iof+i) = ztopsw(i)
       toplw(iof+i) = ztoplw(i)
Index: /LMDZ5/branches/testing/libf/phylmd/read_map2D.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/read_map2D.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/read_map2D.F90	(revision 2408)
@@ -6,5 +6,5 @@
   USE mod_grid_phy_lmdz
   USE mod_phys_lmdz_para
-
+  USE print_control_mod, ONLY: lunout
 
   IMPLICIT NONE
@@ -27,5 +27,4 @@
   REAL, DIMENSION(nbp_lon,nbp_lat) :: var_glo2D_tmp ! 2D global
   REAL, DIMENSION(klon_glo)        :: var_glo1D     ! 1D global
-  INCLUDE "iniprint.h"
 
 ! Read variable from file. Done by master process MPI and master thread OpenMP
@@ -66,7 +65,7 @@
   CONTAINS
     SUBROUTINE write_err_mess(err_mess)
-
+      USE print_control_mod, ONLY: lunout
+      IMPLICIT NONE
       CHARACTER(len=*), INTENT(IN) :: err_mess
-      INCLUDE "iniprint.h"
       
       WRITE(lunout,*) 'Error in read_map2D, filename = ', trim(filename)
@@ -74,5 +73,5 @@
       WRITE(lunout,*) 'Error in read_map2D, timestep = ', timestep
 
-      CALL abort_gcm(modname, err_mess, 1)
+      CALL abort_physic(modname, err_mess, 1)
 
     END SUBROUTINE write_err_mess
Index: /LMDZ5/branches/testing/libf/phylmd/read_pstoke.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/read_pstoke.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/read_pstoke.F90	(revision 2408)
@@ -19,41 +19,39 @@
   USE netcdf
   USE dimphy
-  USE control_mod
   USE indice_sol_mod
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev
 
   IMPLICIT NONE
 
   include "netcdf.inc"
-  include "dimensions.h"
-  include "paramet.h"
-  include "comconst.h"
-  include "comgeom.h"
-  include "temps.h"
-  include "ener.h"
-  include "logic.h"
-  include "description.h"
-  include "serre.h"
-  ! ccc#include "dimphy.h"
 
   INTEGER klono, klevo, imo, jmo
-  PARAMETER (imo=iim/2, jmo=(jjm+1)/2)
-  PARAMETER (klono=(jmo-1)*imo+2, klevo=llm)
-  REAL phisfi(klono)
-  REAL phisfi2(imo, jmo+1), airefi2(imo, jmo+1)
-
-  REAL mfu(klono, klevo), mfd(klono, klevo)
-  REAL en_u(klono, klevo), de_u(klono, klevo)
-  REAL en_d(klono, klevo), de_d(klono, klevo)
-  REAL coefh(klono, klevo)
-  REAL fm_therm(klono, klevo), en_therm(klono, klevo)
-
-  REAL mfu2(imo, jmo+1, klevo), mfd2(imo, jmo+1, klevo)
-  REAL en_u2(imo, jmo+1, klevo), de_u2(imo, jmo+1, klevo)
-  REAL en_d2(imo, jmo+1, klevo), de_d2(imo, jmo+1, klevo)
-  REAL coefh2(imo, jmo+1, klevo)
-  REAL fm_therm2(imo, jmo+1, klevo)
-  REAL en_therm2(imo, jmo+1, klevo)
-
-  REAL pl(klevo)
+!  PARAMETER (imo=iim/2, jmo=(jjm+1)/2)
+!  PARAMETER (klono=(jmo-1)*imo+2, klevo=llm)
+  REAL :: phisfi(((nbp_lat/2)-1)*(nbp_lon/2)+2) !phisfi(klono)
+  REAL,ALLOCATABLE :: phisfi2(:,:) !phisfi2(imo,jmo+1)
+  REAL,ALLOCATABLE :: airefi2(:,:) !airefi2(imo, jmo+1)
+
+  REAL :: mfu(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) ! mfu(klono, klevo)
+  REAL :: mfd(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) ! mfd(klono, klevo)
+  REAL :: en_u(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !en_u(klono, klevo)
+  REAL :: de_u(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !de_u(klono, klevo)
+  REAL :: en_d(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !en_d(klono, klevo)
+  REAL :: de_d(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !de_d(klono, klevo)
+  REAL :: coefh(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !coefh(klono, klevo)
+  REAL :: fm_therm(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !fm_therm(klono, klevo)
+  REAL :: en_therm(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !en_therm(klono, klevo)
+
+  REAL,ALLOCATABLE :: mfu2(:,:,:) !mfu2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: mfd2(:,:,:) !mfd2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: en_u2(:,:,:) !en_u2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: de_u2(:,:,:) !de_u2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: en_d2(:,:,:) !en_d2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: de_d2(:,:,:) !de_d2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: coefh2(:,:,:) !coefh2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: fm_therm2(:,:,:) !fm_therm2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: en_therm2(:,:,:) !en_therm2(imo, jmo+1, klevo)
+
+  REAL,ALLOCATABLE :: pl(:) !pl(klevo)
   INTEGER irec
   INTEGER xid, yid, zid, tid
@@ -61,5 +59,5 @@
   INTEGER ncrec, ncklono, ncklevo, ncim, ncjm
 
-  REAL airefi(klono)
+  REAL :: airefi(((nbp_lat/2)-1)*(nbp_lon/2)+2) !airefi(klono)
   CHARACTER *20 namedim
 
@@ -69,43 +67,75 @@
 
 
-  REAL frac_impa(klono, klevo), frac_nucl(klono, klevo)
-  REAL frac_impa2(imo, jmo+1, klevo), frac_nucl2(imo, jmo+1, klevo)
-  REAL pyu1(klono), pyv1(klono)
-  REAL pyu12(imo, jmo+1), pyv12(imo, jmo+1)
-  REAL ftsol(klono, nbsrf)
-  REAL psrf(klono, nbsrf)
-  REAL ftsol1(klono), ftsol2(klono), ftsol3(klono), ftsol4(klono)
-  REAL psrf1(klono), psrf2(klono), psrf3(klono), psrf4(klono)
-  REAL ftsol12(imo, jmo+1), ftsol22(imo, jmo+1), ftsol32(imo, jmo+1), &
-    ftsol42(imo, jmo+1)
-  REAL psrf12(imo, jmo+1), psrf22(imo, jmo+1), psrf32(imo, jmo+1), &
-    psrf42(imo, jmo+1)
-  REAL t(klono, klevo)
-  REAL t2(imo, jmo+1, klevo)
-  INTEGER ncidp
-  SAVE ncidp
-  INTEGER varidt
-  INTEGER varidmfu, varidmfd, varidps, varidenu, variddeu
-  INTEGER varidend, varidded, varidch, varidfi, varidfn
-  INTEGER varidfmth, varidenth
-  INTEGER varidyu1, varidyv1, varidpl, varidai, varididvt
-  INTEGER varidfts1, varidfts2, varidfts3, varidfts4
-  INTEGER varidpsr1, varidpsr2, varidpsr3, varidpsr4
-  SAVE varidmfu, varidmfd, varidps, varidenu, variddeu
-  SAVE varidend, varidded, varidch, varidfi, varidfn
-  SAVE varidfmth, varidenth
-  SAVE varidyu1, varidyv1, varidpl, varidai, varididvt
-  SAVE varidfts1, varidfts2, varidfts3, varidfts4
-  SAVE varidpsr1, varidpsr2, varidpsr3, varidpsr4
-  SAVE varidt
+  REAL :: frac_impa(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !frac_impa(klono, klevo)
+  REAL :: frac_nucl(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !frac_nucl(klono, klevo)
+  REAL,ALLOCATABLE :: frac_impa2(:,:,:) !frac_impa2(imo, jmo+1, klevo)
+  REAL,ALLOCATABLE :: frac_nucl2(:,:,:) !frac_nucl2(imo, jmo+1, klevo)
+  REAL :: pyu1(((nbp_lat/2)-1)*(nbp_lon/2)+2) !pyu1(klono)
+  REAL :: pyv1(((nbp_lat/2)-1)*(nbp_lon/2)+2) !pyv1(klono)
+  REAL,ALLOCATABLE :: pyu12(:,:), pyv12(:,:) !pyu12(imo, jmo+1), pyv12(imo, jmo+1)
+  REAL :: ftsol(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !ftsol(klono, nbsrf)
+  REAL :: psrf(((nbp_lat/2)-1)*(nbp_lon/2)+2,nbp_lev) !psrf(klono, nbsrf)
+  REAL,ALLOCATABLE :: ftsol1(:),ftsol2(:) !ftsol1(klono), ftsol2(klono)
+  REAL,ALLOCATABLE :: ftsol3(:),ftsol4(:) !ftsol3(klono), ftsol4(klono)
+  REAL,ALLOCATABLE :: psrf1(:), psrf2(:) !psrf1(klono), psrf2(klono)
+  REAL,ALLOCATABLE :: psrf3(:), psrf4(:) !psrf3(klono), psrf4(klono)
+  REAL,ALLOCATABLE :: ftsol12(:,:) !ftsol12(imo, jmo+1)
+  REAL,ALLOCATABLE :: ftsol22(:,:) !ftsol22(imo, jmo+1)
+  REAL,ALLOCATABLE :: ftsol32(:,:) !ftsol32(imo, jmo+1)
+  REAL,ALLOCATABLE :: ftsol42(:,:) !ftsol42(imo, jmo+1)
+  REAL,ALLOCATABLE :: psrf12(:,:) !psrf12(imo, jmo+1)
+  REAL,ALLOCATABLE :: psrf22(:,:) !psrf22(imo, jmo+1)
+  REAL,ALLOCATABLE :: psrf32(:,:) !psrf32(imo, jmo+1)
+  REAL,ALLOCATABLE :: psrf42(:,:) !psrf42(imo, jmo+1)
+  REAL :: t(((nbp_lon/2)-1)*(nbp_lat/2)+2,nbp_lev) !t(klono, klevo)
+  REAL,ALLOCATABLE :: t2(:,:,:) !t2(imo, jmo+1, klevo)
+  INTEGER,SAVE :: ncidp
+  INTEGER,SAVE :: varidt
+  INTEGER,SAVE :: varidmfu, varidmfd, varidps, varidenu, variddeu
+  INTEGER,SAVE :: varidend, varidded, varidch, varidfi, varidfn
+  INTEGER,SAVE :: varidfmth, varidenth
+  INTEGER,SAVE :: varidyu1, varidyv1, varidpl, varidai, varididvt
+  INTEGER,SAVE :: varidfts1, varidfts2, varidfts3, varidfts4
+  INTEGER,SAVE :: varidpsr1, varidpsr2, varidpsr3, varidpsr4
 
   INTEGER l, i
   INTEGER start(4), count(4), status
   REAL rcode
-  LOGICAL first
-  SAVE first
-  DATA first/.TRUE./
-
-
+  LOGICAL,SAVE :: first=.TRUE.
+
+  ! Allocate arrays
+  imo=nbp_lon/2
+  jmo=nbp_lat/2
+  klono=(jmo-1)*imo+2
+  klevo=nbp_lev
+  
+  ALLOCATE(phisfi2(imo,jmo+1))
+  ALLOCATE(airefi2(imo, jmo+1))
+  ALLOCATE(mfu2(imo, jmo+1, klevo))
+  ALLOCATE(mfd2(imo, jmo+1, klevo))
+  ALLOCATE(en_u2(imo, jmo+1, klevo))
+  ALLOCATE(de_u2(imo, jmo+1, klevo))
+  ALLOCATE(en_d2(imo, jmo+1, klevo))
+  ALLOCATE(de_d2(imo, jmo+1, klevo))
+  ALLOCATE(coefh2(imo, jmo+1, klevo))
+  ALLOCATE(fm_therm2(imo, jmo+1, klevo))
+  ALLOCATE(en_therm2(imo, jmo+1, klevo))
+  ALLOCATE(pl(klevo))
+  ALLOCATE(frac_impa2(imo, jmo+1, klevo))
+  ALLOCATE(frac_nucl2(imo, jmo+1, klevo))
+  ALLOCATE(pyu12(imo, jmo+1), pyv12(imo, jmo+1))
+  ALLOCATE(ftsol1(klono), ftsol2(klono))
+  ALLOCATE(ftsol3(klono), ftsol4(klono))
+  ALLOCATE(psrf1(klono), psrf2(klono))
+  ALLOCATE(psrf3(klono), psrf4(klono))
+  ALLOCATE(ftsol12(imo, jmo+1))
+  ALLOCATE(ftsol22(imo, jmo+1))
+  ALLOCATE(ftsol32(imo, jmo+1))
+  ALLOCATE(ftsol42(imo, jmo+1))
+  ALLOCATE(psrf12(imo, jmo+1))
+  ALLOCATE(psrf22(imo, jmo+1))
+  ALLOCATE(psrf32(imo, jmo+1))
+  ALLOCATE(psrf42(imo, jmo+1))
+  ALLOCATE(t2(imo, jmo+1, klevo))
 
   ! ---------------------------------------------
